#ifndef INCLUDED_OFFICECFG_OFFICE_JAVA_HXX
#define INCLUDED_OFFICECFG_OFFICE_JAVA_HXX

#include "sal/config.h"

#include <optional>
#include "com/sun/star/uno/Sequence.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace Java {

struct VirtualMachine: public comphelper::ConfigurationGroup< VirtualMachine> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine"); return PATH; }

struct Home: public comphelper::ConfigurationProperty<Home, OUString> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Home"); return PATH; }
private:
    Home(); // not defined
    ~Home(); // not defined
};

struct Version: public comphelper::ConfigurationProperty<Version, OUString> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Version"); return PATH; }
private:
    Version(); // not defined
    ~Version(); // not defined
};

struct Enable: public comphelper::ConfigurationProperty<Enable, bool> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Enable"); return PATH; }
private:
    Enable(); // not defined
    ~Enable(); // not defined
};

struct Security: public comphelper::ConfigurationProperty<Security, bool> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Security"); return PATH; }
private:
    Security(); // not defined
    ~Security(); // not defined
};

struct NetAccess: public comphelper::ConfigurationProperty<NetAccess, std::optional<sal_Int32> > {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/NetAccess"); return PATH; }
private:
    NetAccess(); // not defined
    ~NetAccess(); // not defined
};

struct UserClassPath: public comphelper::ConfigurationProperty<UserClassPath, OUString> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/UserClassPath"); return PATH; }
private:
    UserClassPath(); // not defined
    ~UserClassPath(); // not defined
};

struct Debug: public comphelper::ConfigurationProperty<Debug, std::optional<bool> > {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Debug"); return PATH; }
private:
    Debug(); // not defined
    ~Debug(); // not defined
};

struct Properties: public comphelper::ConfigurationProperty<Properties, std::optional<com::sun::star::uno::Sequence<OUString> > > {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/Properties"); return PATH; }
private:
    Properties(); // not defined
    ~Properties(); // not defined
};

struct RunUnoComponentsOutOfProcess: public comphelper::ConfigurationProperty<RunUnoComponentsOutOfProcess, bool> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.Office.Java/VirtualMachine/RunUnoComponentsOutOfProcess"); return PATH; }
private:
    RunUnoComponentsOutOfProcess(); // not defined
    ~RunUnoComponentsOutOfProcess(); // not defined
};

private:
    VirtualMachine(); // not defined
    ~VirtualMachine(); // not defined
};

} } }

#endif
