#ifndef INCLUDED_OFFICECFG_TYPEDETECTION_MISC_HXX
#define INCLUDED_OFFICECFG_TYPEDETECTION_MISC_HXX

#include "sal/config.h"

#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace TypeDetection { namespace Misc {

struct FrameLoaders: public comphelper::ConfigurationSet< FrameLoaders> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.TypeDetection.Misc/FrameLoaders"); return PATH; }
private:
    FrameLoaders(); // not defined
    ~FrameLoaders(); // not defined
};

struct ContentHandlers: public comphelper::ConfigurationSet< ContentHandlers> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.TypeDetection.Misc/ContentHandlers"); return PATH; }
private:
    ContentHandlers(); // not defined
    ~ContentHandlers(); // not defined
};

struct Defaults: public comphelper::ConfigurationGroup< Defaults> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.TypeDetection.Misc/Defaults"); return PATH; }

struct DefaultFrameLoader: public comphelper::ConfigurationProperty<DefaultFrameLoader, OUString> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.TypeDetection.Misc/Defaults/DefaultFrameLoader"); return PATH; }
private:
    DefaultFrameLoader(); // not defined
    ~DefaultFrameLoader(); // not defined
};

struct ShowAlienFilterWarning: public comphelper::ConfigurationProperty<ShowAlienFilterWarning, bool> {
    static OUString path() { static const OUStringLiteral PATH(u"/org.openoffice.TypeDetection.Misc/Defaults/ShowAlienFilterWarning"); return PATH; }
private:
    ShowAlienFilterWarning(); // not defined
    ~ShowAlienFilterWarning(); // not defined
};

private:
    Defaults(); // not defined
    ~Defaults(); // not defined
};

} } }

#endif
